-- quick port of the Bunnymark test from https://github.com/pixijs/bunny-mark/tree/master/src
-- CLICK TO ADD BUNNIES

local random = math.random
local _bunnyTex = Texture.new("bunny.png") -- bunny texture: 26x37
local bunnies = {}                         -- table holding bunnies
local nBunnies = 0                         -- number of bunnies
local isAdding = false                     -- flag, indicates if bunnies should be added
WIN_WIDTH @ 800
WIN_HEIGHT @ 600
ADD_PER_FRAME @ 100                        -- number of bunnies to be added per frame               


application:setLogicalDimensions(WIN_WIDTH,WIN_HEIGHT)

local function mouseDown() isAdding = true end
local function mouseUp() isAdding = false end

stage:addEventListener(Event.MOUSE_DOWN, mouseDown)
stage:addEventListener(Event.MOUSE_UP, mouseUp)


local bunny_text = TextField.new(nil, "Bunnies: 0")
bunny_text:setScale(2)
bunny_text:setTextColor(0xFF00FF)
bunny_text:setPosition(20,30)
local fps_text = TextField.new(nil, "0")
fps_text:setScale(2)
fps_text:setTextColor(0xFF00FF)
fps_text:setPosition(20,55)
local bg_area = Pixel.new(0xFFFFFF, 0.8, 260, 70)

local function update(ev)
	local dt = ev.deltaTime
	
	if isAdding then
		for i = 1,ADD_PER_FRAME do
			local bunny = Bitmap.new(_bunnyTex, BUNNY_WIDTH, BUNNY_HEIGHT)
			bunny:setAnchorPoint(0.5,1)
			bunny.speedX = random() * 10
			bunny.speedY = (random() * 10) - 5
			stage:addChild(bunny)
			table.insert(bunnies, bunny)
		end
		nBunnies = nBunnies + ADD_PER_FRAME
		bunny_text:setText("Bunnies: "..nBunnies)
	end
	-- update all bunny positions
	for _,b in ipairs(bunnies) do
		local x,y = b:getPosition()
		local speedX = b.speedX
		local speedY = b.speedY
		
		x = x + speedX
		y = y + speedY
		speedY = speedY + 0.75
		
		if (x > WIN_WIDTH) then
			speedX = -speedX 
			x = WIN_WIDTH
		elseif (x < 0) then
			speedX = -speedX
		end
		
		if (y > WIN_HEIGHT) then
			speedY = speedY * -0.85
			y = WIN_HEIGHT
			if (random() > 0.05) then
				speedY = speedY - random() * 6
			end
		elseif (y < 0) then
			speedY = 0
			y = 0
		end
			
		b:setPosition(x,y)
		b.speedX = speedX
		b.speedY = speedY
	end
	---[[
	local fps = 1/dt
	fps_text:setText("FPS: "..fps)
	stage:addChild(bg_area)
	stage:addChild(fps_text)
	stage:addChild(bunny_text)
	--]]
end
stage:addEventListener(Event.ENTER_FRAME, update)


